import HsShellScript
import System.Posix


main = mainwrapper $ do
   logm "1. With run:\n"
   doit run "ls" ["/"]
   doit run "ls" ["/frooble"]

   logm "\n\n\n2. With runprog:\n"
   doit runprog "ls" ["/"]
   doit runprog "ls" ["/frooble"]

   logm "\n\n\n3. With runprog, terminating with a signal:\n"
   spawn (do sleep 1
             runprog "killall" ["sleep"]
         )
   runprog "sleep" ["3"]


doit fkt prog par = 
   do logm ("Calling " ++ shell_command prog par ++ ": ")
      fkt prog par
      logm ""
   `catch`    (\ioe -> outm (show_ioerror ioe))
   `catchDyn` (\(ps::ProcessStatus) -> outm ("ProcessStatus = " ++ show ps))
   `catchDyn` (\(re::RunError) -> outm ("RunError message =\n" ++ show_runerror re))

